package org.eclipse.stp.sc.jaxwsri.kitprocessor;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;
import java.util.jar.Attributes;
import java.util.jar.JarFile;
import java.util.jar.Manifest;

import org.eclipes.stp.soas.deploy.runtime.jaxwsri.core.internal.IJaxwsRIRuntime;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.eclipse.jdt.core.IClasspathEntry;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.launching.IRuntimeClasspathEntry;
import org.eclipse.stp.common.logging.LoggingProxy;
import org.eclipse.stp.sc.common.internal.model.RuntimeCore;
import org.eclipse.stp.sc.common.workspace.WorkspaceManager;
import org.eclipse.stp.sc.jaxws.runtimeprovider.IRuntimeKitProcessor;
import org.eclipse.wst.server.core.IRuntime;

public class JAXWSRIKitProcessorTemplate implements IRuntimeKitProcessor
{
	
	public void clearJavaProjectBuildPath(IJavaProject project)
	throws JavaModelException, CoreException {

		IPath runtimePath = RuntimeCore.getInstallPath(project.getProject());
		String varName = runtimePath.toOSString();
		if(varName == null){
			return;
		}
		WorkspaceManager.removeEntriesFromClassPath(project, varName);
	}

	public void completeJavaProjectBuildPath(IJavaProject project)
	throws JavaModelException, CoreException {
		IRuntime runtime = RuntimeCore.getRuntime(project.getProject());
		IJaxwsRIRuntime cxfRuntime = (IJaxwsRIRuntime)runtime.loadAdapter(IJaxwsRIRuntime.class, null);
		List<IRuntimeClasspathEntry> libs = cxfRuntime.getRuntimeClasspath();
		ArrayList<IClasspathEntry> clsLibs = new ArrayList<IClasspathEntry>();
		for (IRuntimeClasspathEntry runtimeEntry : libs) {
			clsLibs.add(runtimeEntry.getClasspathEntry());
		}
		WorkspaceManager.addEntriesToClassPath(project, clsLibs); 
	}
}
