/*******************************************************************************
 * Copyright (c) 2004-2006 Sybase, Inc.
 * 
 * All rights reserved. This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License v1.0 which
 * accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: Sybase, Inc. - initial API and implementation
 ******************************************************************************/
package org.eclipse.stp.soas.deploy.core;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IStatus;


/**
 * This is an opaque object used for managing configuration information that can
 * be associated with a physical package.  The deployment framework uses an
 * IPackageConfigurationManager to manage the lifecycle of this object.
 * 
 * @author rcernich
 *
 * Created on Mar 16, 2004
 */
public interface IPackageConfiguration extends IAdaptable {
	
	public ILogicalPackage getPackage();
	
	public IStatus[] validate();
	
	public void dispose();

}
